/*
Scrivere un programma C che calcoli la funzione "=>" (deriva) su parse tree, data
una grammatica libera (vedi lucidi relativi). Allo scopo, si completi il testo con 
le assunzioni e i vincoli che si ritengano necessari apportare.
Assunzioni.

 (1) Le strutture di albero devono poter avere dimensione arbitraria (nessun li-
	 sul numero di archi e nodi) e sono fornite dal modulo "parseTree.h".
 (2) La grammatica data è codificata mediante un'opportuna funzione "rules" che dato 
     un Nonterminale ed un indice, i, fornisce la parte destra della i-esima produzione
	 di tale Nonterminale
 
 (3) Strutturiamo in 3 moduli:
		- Deriva.c: contiene la definizione di Deriva e il main dell'applicazione
		- ParseTree.c e ParseTree.h: definizioni ed headers dell'implementazione dei
			parse tree e delle liste di parse tree
		- Grammatica.c: contiene rappresentazione della grammatica utilizzata nella
			applicazione
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "parseTree.h"
#include "Grammatica.c"

bool Deriva(parseTree tree, int index){
    //index=1 for the first alternative
    if (isEmpty(tree)||(isLeaf(tree)&&((tree)->labelKind==1))) return false;
    if (isLeaf(tree)){
        return(rules(index,tree));
    }
    {//scan the sons
        treeList sons = tree->sons;
        bool flag = false;
        parseTree first;
        treeList others;
        while(split(sons,&first,&others)&&!flag){
            flag = Deriva(first,index);
            sons = others;
        }
        return flag;
    }
}

int main(void){
    parseTree treea = makeLeaf(1,T1);
    parseTree treeA = makeLeaf(0,NT2);
    parseTree treeB = makeLeaf(0,NT3);
    treeList list1 = cons(treea,cons(treeA,nil()));
    parseTree tree1 = makeRooted(NT2,list1);
    parseTree tree = makeRooted(NT1,cons(tree1,cons(treeB,nil())));
    //---- for test
    printlnTree(tree);
    //printTreeSons(cons(tree1,cons(treeB,nil())));
    //printf("\n");
    Deriva(tree,1);
    printlnTree(tree);
    Deriva(tree,1);
    printlnTree(tree);
    Deriva(tree,1);
    printlnTree(tree);
    Deriva(tree,0);
    Deriva(tree,1);
    Deriva(tree,0);
    printlnTree(tree);
    return 0;
}